diff --git a/tools/perf/util/perf_event_attr_fprintf.c b/tools/perf/util/perf_event_attr_fprintf.c
index d9d70126d505..e2ce4a737ef7 100644
--- a/tools/perf/util/perf_event_attr_fprintf.c
+++ b/tools/perf/util/perf_event_attr_fprintf.c
@@ -7,6 +7,11 @@
 #include <linux/perf_event.h>
 #include "util/evsel_fprintf.h"
 
+#ifdef HAVE_LIBTRACEEVENT
+#include <stdlib.h>
+#include "trace-event.h"
+#endif
+
 struct bit_names {
 	int bit;
 	const char *name;
@@ -92,6 +97,129 @@ static void __p_type_id(char *buf, size_t size, u64 value)
 	}
 }
 
+static void __p_config_hw_cache_id(char *buf, size_t size, u64 value)
+{
+	const char *hw_cache_str, *hw_cache_op_str, *hw_cache_op_result_str;
+
+#define ENUM_PERF_HW_CACHE_ID_CASE(x, s) case x: s = (#x); break;
+#define ENUM_PERF_HW_CACHE_ID_CASE_DEFAULT(s) default: s = NULL; break;
+
+	/* sync with enum perf_hw_cache_id in perf_event.h */
+	switch (value & 0xff) {
+	ENUM_PERF_HW_CACHE_ID_CASE(PERF_COUNT_HW_CACHE_L1D, hw_cache_str)
+	ENUM_PERF_HW_CACHE_ID_CASE(PERF_COUNT_HW_CACHE_L1I, hw_cache_str)
+	ENUM_PERF_HW_CACHE_ID_CASE(PERF_COUNT_HW_CACHE_LL, hw_cache_str)
+	ENUM_PERF_HW_CACHE_ID_CASE(PERF_COUNT_HW_CACHE_DTLB, hw_cache_str)
+	ENUM_PERF_HW_CACHE_ID_CASE(PERF_COUNT_HW_CACHE_ITLB, hw_cache_str)
+	ENUM_PERF_HW_CACHE_ID_CASE(PERF_COUNT_HW_CACHE_BPU, hw_cache_str)
+	ENUM_PERF_HW_CACHE_ID_CASE(PERF_COUNT_HW_CACHE_NODE, hw_cache_str)
+	ENUM_PERF_HW_CACHE_ID_CASE_DEFAULT(hw_cache_str)
+	}
+
+	/* sync with enum perf_hw_cache_op_id in perf_event.h */
+	switch ((value & 0xff00) >> 8) {
+	ENUM_PERF_HW_CACHE_ID_CASE(PERF_COUNT_HW_CACHE_OP_READ, hw_cache_op_str)
+	ENUM_PERF_HW_CACHE_ID_CASE(PERF_COUNT_HW_CACHE_OP_WRITE, hw_cache_op_str)
+	ENUM_PERF_HW_CACHE_ID_CASE(PERF_COUNT_HW_CACHE_OP_PREFETCH, hw_cache_op_str)
+	ENUM_PERF_HW_CACHE_ID_CASE_DEFAULT(hw_cache_op_str)
+	}
+
+	/* sync with enum perf_hw_cache_op_result_id in perf_event.h */
+	switch ((value & 0xff0000) >> 16) {
+	ENUM_PERF_HW_CACHE_ID_CASE(PERF_COUNT_HW_CACHE_RESULT_ACCESS, hw_cache_op_result_str)
+	ENUM_PERF_HW_CACHE_ID_CASE(PERF_COUNT_HW_CACHE_RESULT_MISS, hw_cache_op_result_str)
+	ENUM_PERF_HW_CACHE_ID_CASE_DEFAULT(hw_cache_op_result_str)
+	}
+
+#undef ENUM_PERF_HW_CACHE_ID_CASE
+#undef ENUM_PERF_HW_CACHE_ID_CASE_DEFULT
+
+	if (hw_cache_str == NULL || hw_cache_op_str == NULL ||
+	    hw_cache_op_result_str == NULL) {
+		snprintf(buf, size, "%#"PRIx64, value);
+	} else {
+		snprintf(buf, size, "%#"PRIx64" (%s | %s | %s)", value,
+			 hw_cache_op_result_str, hw_cache_op_str, hw_cache_str);
+	}
+}
+
+#ifdef HAVE_LIBTRACEEVENT
+static void __p_config_tracepoint_id(char *buf, size_t size, u64 value)
+{
+	char *name = tracepoint_id_to_name(value);
+
+	if (name != NULL) {
+		snprintf(buf, size, "%#"PRIx64" (%s)", value, name);
+		free(name);
+	} else {
+		snprintf(buf, size, "%#"PRIx64, value);
+	}
+}
+#endif
+
+static void __p_config_id(char *buf, size_t size, u32 type, u64 value)
+{
+#define PRINT_ENUM_PERF_CONFIG_ID_CASE(x)				\
+	case x:								\
+		snprintf(buf, size, "%#"PRIx64" (%s)", value, #x);	\
+		return;
+
+#define PRINT_ENUM_PERF_CONFIG_ID_DEFAULT_CASE				\
+	default:							\
+		snprintf(buf, size, "%#"PRIx64, value);			\
+		return;
+
+	switch (type) {
+	case PERF_TYPE_HARDWARE:
+		/* sync with enum perf_hw_cache_id in perf_event.h */
+		switch (value & PERF_HW_EVENT_MASK) {
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_HW_CPU_CYCLES)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_HW_INSTRUCTIONS)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_HW_CACHE_REFERENCES)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_HW_CACHE_MISSES)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_HW_BRANCH_INSTRUCTIONS)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_HW_BRANCH_MISSES)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_HW_BUS_CYCLES)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_HW_STALLED_CYCLES_FRONTEND)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_HW_STALLED_CYCLES_BACKEND)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_HW_REF_CPU_CYCLES)
+		PRINT_ENUM_PERF_CONFIG_ID_DEFAULT_CASE
+		}
+
+	case PERF_TYPE_SOFTWARE:
+		/* sync with enum perf_sw_ids in perf_event.h */
+		switch (value) {
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_SW_CPU_CLOCK)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_SW_TASK_CLOCK)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_SW_PAGE_FAULTS)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_SW_CONTEXT_SWITCHES)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_SW_CPU_MIGRATIONS)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_SW_PAGE_FAULTS_MIN)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_SW_PAGE_FAULTS_MAJ)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_SW_ALIGNMENT_FAULTS)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_SW_EMULATION_FAULTS)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_SW_DUMMY)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_SW_BPF_OUTPUT)
+		PRINT_ENUM_PERF_CONFIG_ID_CASE(PERF_COUNT_SW_CGROUP_SWITCHES)
+		PRINT_ENUM_PERF_CONFIG_ID_DEFAULT_CASE
+		}
+#undef PRINT_ENUM_PERF_CONFIG_ID_CASE
+
+	case PERF_TYPE_HW_CACHE:
+		return __p_config_hw_cache_id(buf, size, value);
+
+	case PERF_TYPE_TRACEPOINT:
+#ifdef HAVE_LIBTRACEEVENT
+		return __p_config_tracepoint_id(buf, size, value);
+#endif
+	case PERF_TYPE_RAW:
+	case PERF_TYPE_BREAKPOINT:
+	PRINT_ENUM_PERF_CONFIG_ID_DEFAULT_CASE
+	}
+
+#undef PRINT_ENUM_PERF_CONFIG_ID_DEFAULT_CASE
+}
+
 #define BUF_SIZE		1024
 
 #define p_hex(val)		snprintf(buf, BUF_SIZE, "%#"PRIx64, (uint64_t)(val))
@@ -101,6 +229,7 @@ static void __p_type_id(char *buf, size_t size, u64 value)
 #define p_branch_sample_type(val) __p_branch_sample_type(buf, BUF_SIZE, val)
 #define p_read_format(val)	__p_read_format(buf, BUF_SIZE, val)
 #define p_type_id(val)		__p_type_id(buf, BUF_SIZE, val)
+#define p_config_id(val)	__p_config_id(buf, BUF_SIZE, attr->type, val)
 
 #define PRINT_ATTRn(_n, _f, _p, _a)			\
 do {							\
@@ -120,7 +249,7 @@ int perf_event_attr__fprintf(FILE *fp, struct perf_event_attr *attr,
 
 	PRINT_ATTRn("type", type, p_type_id, true);
 	PRINT_ATTRf(size, p_unsigned);
-	PRINT_ATTRf(config, p_hex);
+	PRINT_ATTRn("config", config, p_config_id, true);
 	PRINT_ATTRn("{ sample_period, sample_freq }", sample_period, p_unsigned, false);
 	PRINT_ATTRf(sample_type, p_sample_type);
 	PRINT_ATTRf(read_format, p_read_format);